#include<iostream.h>
#include<string>
#include "time.h"

using namespace std;

#define MAX_BALL 3

class Ball
{

private:
    int mNumber;

public:
    Ball()
        : mNumber(0) {};

public:
    int getNumber()
    {
        return mNumber;
    }
    void setNumber(int agNumber)
    {
        mNumber = agNumber;
    }

};

class Answer
{

private:
    Ball*    mBalls;
    int        mIndex;

public:
    Answer()
        :mIndex(0)
    {
        mBalls = new Ball[MAX_BALL];
    }

    bool addAnswer(int agAns)
    {
		for(int i = 0; i < mIndex; i++)
		{
			if (mBalls[i].getNumber() == agAns) return false;
		}

        if (mIndex < MAX_BALL)
        {                
            mBalls[mIndex].setNumber(agAns);
            mIndex++;
        }
		return true;
    }
    
    Ball* getAnswer()
    {
        return mBalls;
    }
    
    int getNumberofBalls()
    {
        return mIndex;
    }
};

class Player 
{    
    
protected:
    Answer*    balls;
    string    playerName;    

    Player()
    {
        
    }
    
    Player(string agName)
    {
        playerName = agName;
    }
    
    Player(Answer* agAnswer)
    {    
        setAnswer(agAnswer);
    }    
    
public:
    string getPlayerName()
    {
        return playerName;
    }
    
    bool checkValidAnswer(Answer* agAnswer)
    {
        int numberOfBalls = agAnswer->getNumberofBalls();
        if (numberOfBalls != MAX_BALL)        
            return false;        
        else
            return true;        
    }
    
    virtual void setAnswer(Answer* agAnswer)
    {
        if (checkValidAnswer(agAnswer))
            balls = agAnswer;
        else
            throw new exception(); 
    }
    
    Answer* getAnswer()
    {
        return balls;
    }
    

    virtual void setAnswer() = 0;        
    virtual Answer* getGuessAnswer() = 0;
};

class BallCount 
{    

private:
    int mCountofStrike;
    int mCountofBall;

public:
    BallCount()
    {
        clear();
    }
    
    bool is3Out()
    {
        return ( mCountofStrike == MAX_BALL );
    }
    
    void clear()
    {
        mCountofBall = 0;
        mCountofStrike = 0;
    }
    
    void checkResult(Player* agPlayer, Answer* agAttacker, Answer* agDefender)
    {
        clear();
        for(int i = 0; i < MAX_BALL; i++)
        {
            if (agAttacker->getAnswer()[i].getNumber() == agDefender->getAnswer()[i].getNumber())            
                mCountofStrike++;
            else
            {
                for(int j = 0; j < MAX_BALL; j++)
                {           
					
                    if (j != i && agAttacker->getAnswer()[i].getNumber() == agDefender->getAnswer()[j].getNumber())                
                        mCountofBall++;                
                }
            }
        }
    }
    
    string getResult()
    {        
        string result = "";		
		char	buf[30];

		sprintf(buf, "%d S, %d B", mCountofStrike, mCountofBall);
        
		result = buf;
        return result;
    }

    int getCountofBall() {
        return mCountofBall;
    }

    int getCountofStrike() {
        return mCountofStrike;
    }

};

class Bot : public Player 
{
private:
	static bool isCheatMode;

public:
    Bot()
        :Player("Bot")
    {}
    
    void setAnswer()
    {        
        Player::setAnswer(getGuessAnswer());        
    }
    
    Answer* getGuessAnswer()
    {        
        Answer*    answer = new Answer();
        
		srand((unsigned)time(NULL));
       
        for (int i = 0; i < 3; i++)
        {   		    
            int temp = rand() % 10;
						
            while(!(answer->addAnswer(temp)))
			{
				 temp = rand() % 10;
			}
			
			if (isCheatMode)
				cout << temp << " ";
        }
        if (isCheatMode) cout << endl;
        
        return answer;
    }

public:
	void static CheatOn()
	{
		isCheatMode = true;
	}
};

bool Bot::isCheatMode = false;

class Human : public Player
{

public:
    Human()
        : Player("Human")
    {}
    
    void setAnswer()
    {    
        Player::setAnswer(getGuessAnswer());        
    }
    
    Answer* getGuessAnswer()
    {    
    
        char	oneline[50];		
		string	oneNumber;
		char*	token;
		char	seps[] = ", ";
        Answer*	answer = new Answer(); 
        
        cout << "Insert the answer.. (ex. 1,3,5)" << endl;         
        cin >> oneline;

		if ( strcmp(oneline, "cheat") == 0 )
		{
			Bot::CheatOn();
			cout << "CHEAT MODE ON " << endl;
			
			cout << "Insert the answer.. (ex. 1,3,5)" << endl;         
			cin >> oneline;
		}
		

		token = strtok(oneline, seps);   
		while(token != NULL)   
		{
			answer->addAnswer(atoi(token)); 
			token = strtok(NULL, seps);    //ū и ڰ ° NULL						
		}       
        
        return answer;        
    }
};


class BaseBallGame
{

private:
    BallCount* ballcount;
    Player* players[2];
    
public:
    BaseBallGame()
    {        
        players[0] = new Human();
        players[1] = new Bot();
        ballcount = new BallCount();
    }
    
    void setGame()
    {
        players[0]->setAnswer();        
        players[1]->setAnswer();
    }    
        
    
    
    void start()
    {
		int i = 1;
        cout << "======================" << endl;
        cout << "The game is starting..." << endl;
        cout << "======================" << endl;
        
        Answer* player0, *player1;
        
        while(true)
        {
			cout << "Player " << i << "th try...." << endl;			

            player0 = players[0]->getGuessAnswer();
            ballcount->checkResult(players[0], player0, players[1]->getAnswer());
            
			delete player0;
            if (ballcount->is3Out())
            {
                cout << players[0]->getPlayerName().c_str() << " WINS!!" << endl;
                break;
            }
            else
                cout << ballcount->getResult().c_str() << endl;

			cout << endl << "Bot " << i++ << "th try...." << endl;			            

            player1 = players[1]->getGuessAnswer();

			for(int k = 0; k < MAX_BALL;k++)
				cout << player1->getAnswer()[k].getNumber();
			cout << endl;
			
            ballcount->checkResult(players[1], player1, players[0]->getAnswer());
            
			delete player1;

            if (ballcount->is3Out())
            {
                cout << players[1]->getPlayerName().c_str() << " WINS!!" << endl;
                break;
            }
            else
                cout << ballcount->getResult().c_str() << endl;

			cout << "==========================" << endl;
        }
    }
    
};

void main()
{
    cout << "======================" << endl;
    cout << "The game is setting..." << endl;
    cout << "======================" << endl;
    
    BaseBallGame* bbgame = new BaseBallGame();
    bbgame->setGame();            
    bbgame->start();
}
