#include<iostream.h>
#include<map>

using namespace std;

class Command
{

public:
    virtual void Invoke(int*, int) = 0;    

};

class CmdPlus : public Command
{

private:
    CmdPlus() {};

    void Invoke(int* agNum1, int agNum2)
    {    
        *agNum1 += agNum2;
    };

    friend class CmdManager;

};

class CmdMinus : public Command
{

private:
    CmdMinus() {};

    void Invoke(int* agNum1, int agNum2)
    {    
        *agNum1 -= agNum2;
    };

    friend class CmdManager;

};

class CmdManager
{

private:
    static                    CmdManager* cm;
    int                        mAnswer;
    map<char, Command*>        mArrayofCmd;

private:
    void Init()
    {
        mAnswer = 0;
        AddCmd();
    }

    void AddCmd()
    {
        mArrayofCmd['+'] = new CmdPlus();
        mArrayofCmd['-'] = new CmdMinus();
    };

public:
    static CmdManager* getInstance()
    {
        if ( cm == NULL)
        {
            CmdManager* instanceOfCM = new CmdManager();
            instanceOfCM->Init();            
            
            return instanceOfCM;
        };

        return cm;
    };
    
    static void destroyInstance()
    {
        if ( cm != NULL)
            delete cm;
    };

    void Invoke(int agNum, char agOperator)
    {        
        mArrayofCmd[agOperator]->Invoke(&mAnswer, agNum);        
    };

    int getAnswer()
    {
        return mAnswer;
    };
    
};

CmdManager* CmdManager::cm = NULL;

void main()
{
    CmdManager* cm = CmdManager::getInstance();

    cm->Invoke(5, '+');
    cm->Invoke(3, '+');
    cm->Invoke(2, '-');

    cout << "Answer = " << cm->getAnswer() << endl;

    CmdManager::destroyInstance();
}

